Index: trunk/source/processes/electromagnetic/standard/src/G4ASTARStopping.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4ASTARStopping.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4ASTARStopping.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ASTARStopping.cc,v 1.8 2008/11/24 18:28:09 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 
 //---------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4BetheBlochModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BetheBlochModel.cc,v 1.31 2009/04/24 14:24:00 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4BetheBlochModel.cc,v 1.34 2009/11/11 23:22:27 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -234,9 +234,9 @@
   G4double eexc  = material->GetIonisation()->GetMeanExcitationEnergy();
   G4double eexc2 = eexc*eexc;
-  G4double cden  = material->GetIonisation()->GetCdensity();
-  G4double mden  = material->GetIonisation()->GetMdensity();
-  G4double aden  = material->GetIonisation()->GetAdensity();
-  G4double x0den = material->GetIonisation()->GetX0density();
-  G4double x1den = material->GetIonisation()->GetX1density();
+  //G4double cden  = material->GetIonisation()->GetCdensity();
+  //G4double mden  = material->GetIonisation()->GetMdensity();
+  //G4double aden  = material->GetIonisation()->GetAdensity();
+  //G4double x0den = material->GetIonisation()->GetX0density();
+  //G4double x1den = material->GetIonisation()->GetX1density();
 
   G4double eDensity = material->GetElectronDensity();
@@ -252,8 +252,9 @@
   // density correction
   G4double x = log(bg2)/twoln10;
-  if ( x >= x0den ) {
-    dedx -= twoln10*x - cden ;
-    if ( x < x1den ) dedx -= aden*pow((x1den-x),mden) ;
-  }
+  //if ( x >= x0den ) {
+  //  dedx -= twoln10*x - cden ;
+  //  if ( x < x1den ) dedx -= aden*pow((x1den-x),mden) ;
+  //}
+  dedx -= material->GetIonisation()->DensityCorrection(x);
 
   // shell correction
@@ -283,11 +284,11 @@
 					     G4double length)
 {
-  const G4ParticleDefinition* p = dp->GetDefinition();
-  const G4Material* mat = couple->GetMaterial();
-  G4double preKinEnergy = dp->GetKineticEnergy();
-  G4double e = preKinEnergy - eloss*0.5;
-  if(e < 0.0) e = preKinEnergy*0.5;
-
   if(isIon) {
+    const G4ParticleDefinition* p = dp->GetDefinition();
+    const G4Material* mat = couple->GetMaterial();
+    G4double preKinEnergy = dp->GetKineticEnergy();
+    G4double e = preKinEnergy - eloss*0.5;
+    if(e < 0.0) e = preKinEnergy*0.5;
+
     G4double q2 = corr->EffectiveChargeSquareRatio(p,mat,e);
     GetModelOfFluctuations()->SetParticleAndCharge(p, q2);
@@ -295,5 +296,5 @@
     eloss += length*corr->IonHighOrderCorrections(p,couple,e);
   }
-
+  /*
   if(nuclearStopping && preKinEnergy*proton_mass_c2/mass < chargeSquare*100.*MeV) {
 
@@ -307,12 +308,12 @@
       eloss += nloss;
     }
-    /*
+    
     G4cout << "G4ionIonisation::CorrectionsAlongStep: e= " << preKinEnergy
     	   << " de= " << eloss << " NIEL= " << nloss 
 	   << " dynQ= " << dp->GetCharge()/eplus << G4endl;
-    */
+    
     fParticleChange->ProposeNonIonizingEnergyDeposit(nloss);
   }
-
+  */
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4BetheHeitlerModel.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BetheHeitlerModel.cc,v 1.13 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4BohrFluctuations.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BohrFluctuations.cc,v 1.7 2009/02/19 19:17:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4BohrFluctuations.cc,v 1.8 2009/09/29 11:33:22 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -63,5 +63,5 @@
  :G4VEmFluctuationModel(nam),
   particle(0),
-  minNumberInteractionsBohr(10.0),
+  minNumberInteractionsBohr(2.0),
   minFraction(0.2),
   xmin(0.2),
@@ -110,6 +110,6 @@
     }
     siga = sqrt(siga);
-    //G4cout << "siga= " << siga << G4endl;
     G4double twomeanLoss = meanLoss + meanLoss;
+    //G4cout << "siga= " << siga << " 2edp= " << twomeanLoss <<G4endl;
 
     if(twomeanLoss < siga) {
@@ -130,5 +130,5 @@
     loss = meanLoss*n/navr;
   }
-  //  G4cout << "loss= " << loss << G4endl;
+  //G4cout << "loss= " << loss << G4endl;
 
   return loss;
Index: trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4BraggIonModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggIonModel.cc,v 1.24 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4BraggIonModel.cc,v 1.26 2009/11/10 19:25:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -136,4 +136,5 @@
 					       G4double kineticEnergy)
 {
+  //G4cout << "G4BraggIonModel::GetChargeSquareRatio e= " <<  kineticEnergy << G4endl;
   // this method is called only for ions
   G4double q2 = corr->EffectiveChargeSquareRatio(p,mat,kineticEnergy);
@@ -148,4 +149,5 @@
 					    G4double kineticEnergy)
 {
+  //G4cout << "G4BraggIonModel::GetParticleCharge e= " <<  kineticEnergy << G4endl;
   // this method is called only for ions
   return corr->GetParticleCharge(p,mat,kineticEnergy);
@@ -252,5 +254,5 @@
 					   G4double& eloss,
 					   G4double&,
-					   G4double length)
+					   G4double /*length*/)
 {
   // this method is called only for ions
@@ -261,8 +263,10 @@
   if(e < 0.0) e = preKinEnergy*0.5;
 
+  //G4cout << "G4BraggIonModel::CorrectionsAlongStep e= " <<  e << G4endl;
+
   G4double q2 = corr->EffectiveChargeSquareRatio(p,mat,e);
   GetModelOfFluctuations()->SetParticleAndCharge(p, q2);
   eloss *= q2*corr->EffectiveChargeCorrection(p,mat,e)/corrFactor; 
-
+  /*
   if(nuclearStopping) {
 
@@ -276,11 +280,13 @@
       eloss += nloss;
     }
-    /*
+    
     G4cout << "G4ionIonisation::CorrectionsAlongStep: e= " << preKinEnergy
     	   << " de= " << eloss << " NIEL= " << nloss 
 	   << " dynQ= " << dp->GetCharge()/eplus << G4endl;
-    */
+    
     fParticleChange->ProposeNonIonizingEnergyDeposit(nloss);
   }
+  */
+  //G4cout << "G4BraggIonModel::CorrectionsAlongStep end" << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4BraggModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggModel.cc,v 1.22 2009/04/09 18:41:18 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4BraggModel.cc,v 1.23 2009/11/10 19:25:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -240,5 +240,5 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
+/*
 void G4BraggModel::CorrectionsAlongStep(const G4MaterialCutsCouple* couple,
 					const G4DynamicParticle* dp,
@@ -263,12 +263,13 @@
       eloss += nloss;
     }
-    /*
+    
     G4cout << "G4ionIonisation::CorrectionsAlongStep: e= " << preKinEnergy
     	   << " de= " << eloss << " NIEL= " << nloss 
 	   << " dynQ= " << dp->GetCharge()/eplus << G4endl;
-    */
+    
     fParticleChange->ProposeNonIonizingEnergyDeposit(nloss);
   }
 }
+*/
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ComptonScattering.cc,v 1.31 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering52.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering52.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4ComptonScattering52.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ComptonScattering52.cc,v 1.7 2008/10/15 17:53:44 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4CoulombScattering.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScattering.cc,v 1.20 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4CoulombScattering.cc,v 1.25 2009/10/28 10:14:13 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -52,5 +52,7 @@
 #include "G4CoulombScatteringModel.hh"
 #include "G4eCoulombScatteringModel.hh"
+//#include "G4hCoulombScatteringModel.hh"
 #include "G4Electron.hh"
+#include "G4Proton.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
@@ -103,9 +105,9 @@
     aParticle = p;
     G4double mass = p->GetPDGMass();
+    G4String name = p->GetParticleName();
     if (mass > GeV || p->GetParticleType() == "nucleus") {
       SetBuildTableFlag(false);
       verboseLevel = 0;
     } else {
-      G4String name = p->GetParticleName();
       if(name != "e-" && name != "e+" &&
          name != "mu+" && name != "mu-" && name != "pi+" && 
@@ -115,4 +117,12 @@
     G4double emin = MinKinEnergy();
     G4double emax = MaxKinEnergy();
+    //    G4gCoulombScatteringModel* model = new G4hCoulombScatteringModel();
+    G4eCoulombScatteringModel* model = new G4eCoulombScatteringModel();
+    model->SetPolarAngleLimit(PolarAngleLimit());
+    model->SetLowEnergyLimit(emin);
+    model->SetHighEnergyLimit(emax);
+    AddEmModel(1, model);
+    /*
+
     G4double eth  = thEnergy;
     if(mass < MeV) eth  = thEnergyElec; 
@@ -131,4 +141,5 @@
       AddEmModel(2, model);
     }
+    */
   }
 }
@@ -139,6 +150,7 @@
 {
   G4cout << "      " << PolarAngleLimit()/degree
-	 << " < Theta(degree) < 180" 
+	 << " < Theta(degree) < 180"
 	 << ", Eth(MeV)= ";
+
   if(aParticle->GetPDGMass() < MeV) G4cout << thEnergyElec;
   else                              G4cout << thEnergy;
Index: trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4CoulombScatteringModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScatteringModel.cc,v 1.39 2009/05/10 16:09:29 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4CoulombScatteringModel.cc,v 1.43 2009/10/28 10:14:13 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -39,4 +39,5 @@
 //
 // Modifications:
+//
 // 01.08.06 V.Ivanchenko extend upper limit of table to TeV and review the
 //          logic of building - only elements from G4ElementTable
@@ -45,4 +46,6 @@
 // 09.10.07 V.Ivanchenko reorganized methods, add cut dependence in scattering off e- 
 // 09.06.08 V.Ivanchenko SelectIsotope is moved to the base class
+// 16.06.09 Consolandi rows 109, 111-112, 183, 185-186
+//
 //
 // Class Description:
@@ -84,6 +87,6 @@
 {
   SetupParticle(p);
-  G4double ekin = std::max(lowEnergyLimit, kinEnergy);
-  SetupKinematic(ekin, cutEnergy);
+  if(kinEnergy < lowEnergyLimit) return 0.0;
+  SetupKinematic(kinEnergy, cutEnergy);
 
   // save lab system kinematics
@@ -103,5 +106,9 @@
   mom2 = momCM*momCM;
   tkin = sqrt(mom2 + m12) - mass;
-  invbeta2 = 1.0 +  m12/mom2;
+
+  //invbeta2 = 1.0 +  m12/mom2;
+ 
+  G4double fm = m2/(mass + m2);
+  invbeta2 = 1.0 +  m12*fm*fm/mom2;
 
   SetupTarget(Z, tkin);
@@ -127,12 +134,12 @@
 {
   G4double kinEnergy = dp->GetKineticEnergy();
-  if(kinEnergy <= DBL_MIN) return;
+  if(kinEnergy < lowEnergyLimit) return;
   DefineMaterial(couple);
   SetupParticle(dp->GetDefinition());
-  G4double ekin = std::max(lowEnergyLimit, kinEnergy);
-  SetupKinematic(ekin, cutEnergy);
+  SetupKinematic(kinEnergy, cutEnergy);
 
   // Choose nucleus
-  currentElement = SelectRandomAtom(couple,particle,ekin,ecut,tkin);
+  currentElement = SelectRandomAtom(couple,particle,
+				    kinEnergy,ecut,kinEnergy);
 
   G4double Z  = currentElement->GetZ();
@@ -160,5 +167,4 @@
   G4double z1   = 1.0 - cost;
   if(z1 < 0.0) return;
-
   G4double sint = sqrt(z1*(1.0 + cost));
   G4double phi  = twopi * G4UniformRand();
@@ -175,15 +181,23 @@
   fParticleChange->ProposeMomentumDirection(newDirection);   
 
-  G4double elab = gam*(eCM + bet*pzCM);
-  ekin = elab - mass;
-  if(ekin < 0.0) ekin = 0.0;
-  fParticleChange->SetProposedKineticEnergy(ekin);
+  //  G4double elab = gam*(eCM + bet*pzCM);
+
+  G4double Ecm  = sqrt(mass*mass + m2*m2 + 2.0*etot*m2);
+  G4double elab = etot - m2*(ptot/Ecm)*(ptot/Ecm)*(1.-cost) ;
+
+ 
+  G4double finalT = elab - mass;
+  if(finalT < 0.0) finalT = 0.0;
+  fParticleChange->SetProposedKineticEnergy(finalT);
 
   // recoil
-  G4double erec = kinEnergy - ekin;
-
-  if(erec > recoilThreshold) {
+  G4double erec = kinEnergy - finalT;
+
+  G4double tcut = recoilThreshold;
+  if(pCuts) { tcut= std::max(tcut,(*pCuts)[currentMaterialIndex]); } 
+
+  if(erec > tcut) {
     G4ParticleDefinition* ion = theParticleTable->FindIon(iz, ia, 0, iz);
-    G4double plab = sqrt(ekin*(ekin + 2.0*mass));
+    G4double plab = sqrt(finalT*(finalT + 2.0*mass));
     G4ThreeVector p2 = (ptot*dir - plab*newDirection).unit();
     G4DynamicParticle* newdp  = new G4DynamicParticle(ion, p2, erec);
Index: trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4GammaConversion.cc	(revision 1196)
@@ -25,5 +25,5 @@
 //
 // $Id: G4GammaConversion.cc,v 1.31 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
